<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/SpeechEncoder/include/SpeechEncoder/SpeechEncoder.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_6b07903b29b547047bfa8a8b819c80bf.html">SpeechEncoder</a></li><li class="navelem"><a class="el" href="dir_42bcecaea8b07e2c1ef02db2f3150d05.html">include</a></li><li class="navelem"><a class="el" href="dir_cbacebecc382a655c7378ad9d0546a4b.html">SpeechEncoder</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">SpeechEncoder.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_speech_encoder_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_SPEECHENCODER_INCLUDE_SPEECHENCODER_SPEECHENCODER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_SPEECHENCODER_INCLUDE_SPEECHENCODER_SPEECHENCODER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;atomic&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_audio_input_stream_8h.html">AVSCommon/AVS/AudioInputStream.h</a>&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_audio_format_8h.html">AVSCommon/Utils/AudioFormat.h</a>&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_executor_8h.html">AVSCommon/Utils/Threading/Executor.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_encoder_context_8h.html">EncoderContext.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">namespace </span>speechencoder {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html">   37</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html">SpeechEncoder</a> {</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a2e33ddd0cc385fc263cc987b2f9ba293">SpeechEncoder</a>(<span class="keyword">const</span> std::shared_ptr&lt;EncoderContext&gt;&amp; encoder);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a527b26610b537a3eae200a08eb1c892d">~SpeechEncoder</a>();</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a61b44d15f354d5bf8a51921169d3825e">startEncoding</a>(</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keyword">const</span> std::shared_ptr&lt;alexaClientSDK::avsCommon::avs::AudioInputStream&gt;&amp; inputStream,</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">alexaClientSDK::avsCommon::utils::AudioFormat</a> inputFormat,</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#a6b73c95dbde8b184f8b3176ff9a3f3f1">avsCommon::avs::AudioInputStream::Index</a> begin,</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <a class="code" href="_reader_8h.html#af8301ba5b9319ad0427cfe10efcf91ba">avsCommon::avs::AudioInputStream::Reader::Reference</a> reference);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#ae795f8032c949bd1ad867219112d09fe">stopEncoding</a>(<span class="keywordtype">bool</span> stopImmediately = <span class="keyword">false</span>);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    std::shared_ptr&lt;alexaClientSDK::avsCommon::avs::AudioInputStream&gt; <a class="code" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a8017f4c8449731caf668f851720cdb06">getEncodedStream</a>();</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    std::shared_ptr&lt;EncoderContext&gt; <a class="code" href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a57333ee24742fd8ce80a3f0a7c0ed374">getContext</a>();</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordtype">void</span> encodeLoop(</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#a6b73c95dbde8b184f8b3176ff9a3f3f1">avsCommon::avs::AudioInputStream::Index</a> begin,</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <a class="code" href="_reader_8h.html#af8301ba5b9319ad0427cfe10efcf91ba">avsCommon::avs::AudioInputStream::Reader::Reference</a> reference);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    std::shared_ptr&lt;EncoderContext&gt; m_encoder;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">alexaClientSDK::avsCommon::utils::AudioFormat</a> m_inputAudioFormat;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    std::shared_ptr&lt;alexaClientSDK::avsCommon::avs::AudioInputStream&gt; m_inputStream;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">alexaClientSDK::avsCommon::utils::AudioFormat</a> m_outputAudioFormat;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordtype">size_t</span> m_maxFrameSize;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    std::shared_ptr&lt;alexaClientSDK::avsCommon::avs::AudioInputStream&gt; m_encodedStream;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    std::atomic&lt;bool&gt; m_isEncoding;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    std::atomic&lt;bool&gt; m_stopRequested;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">avsCommon::utils::threading::Executor</a> m_executor;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;};</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;}  <span class="comment">// namespace speechencoder</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_SPEECHENCODER_INCLUDE_SPEECHENCODER_SPEECHENCODER_H_</span></div><div class="ttc" id="_reader_8h_html_af8301ba5b9319ad0427cfe10efcf91ba"><div class="ttname"><a href="_reader_8h.html#af8301ba5b9319ad0427cfe10efcf91ba">Reference</a></div><div class="ttdeci">Reference</div><div class="ttdoc">Specifies a reference to measure seek()/tell()/close() offsets against. </div><div class="ttdef"><b>Definition:</b> Reader.h:50</div></div>
<div class="ttc" id="_audio_input_stream_8h_html"><div class="ttname"><a href="_audio_input_stream_8h.html">AudioInputStream.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">alexaClientSDK::avsCommon::utils::threading::Executor</a></div><div class="ttdef"><b>Definition:</b> Executor.h:39</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder_html_a2e33ddd0cc385fc263cc987b2f9ba293"><div class="ttname"><a href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a2e33ddd0cc385fc263cc987b2f9ba293">alexaClientSDK::speechencoder::SpeechEncoder::SpeechEncoder</a></div><div class="ttdeci">SpeechEncoder(const std::shared_ptr&lt; EncoderContext &gt; &amp;encoder)</div><div class="ttdef"><b>Definition:</b> SpeechEncoder.cpp:53</div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_audio_format.html">alexaClientSDK::avsCommon::utils::AudioFormat</a></div><div class="ttdef"><b>Definition:</b> AudioFormat.h:31</div></div>
<div class="ttc" id="_audio_format_8h_html"><div class="ttname"><a href="_audio_format_8h.html">AudioFormat.h</a></div></div>
<div class="ttc" id="_executor_8h_html"><div class="ttname"><a href="_executor_8h.html">Executor.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder_html_a57333ee24742fd8ce80a3f0a7c0ed374"><div class="ttname"><a href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a57333ee24742fd8ce80a3f0a7c0ed374">alexaClientSDK::speechencoder::SpeechEncoder::getContext</a></div><div class="ttdeci">std::shared_ptr&lt; EncoderContext &gt; getContext()</div><div class="ttdef"><b>Definition:</b> SpeechEncoder.cpp:122</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder_html_ae795f8032c949bd1ad867219112d09fe"><div class="ttname"><a href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#ae795f8032c949bd1ad867219112d09fe">alexaClientSDK::speechencoder::SpeechEncoder::stopEncoding</a></div><div class="ttdeci">void stopEncoding(bool stopImmediately=false)</div><div class="ttdef"><b>Definition:</b> SpeechEncoder.cpp:106</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder_html_a8017f4c8449731caf668f851720cdb06"><div class="ttname"><a href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a8017f4c8449731caf668f851720cdb06">alexaClientSDK::speechencoder::SpeechEncoder::getEncodedStream</a></div><div class="ttdeci">std::shared_ptr&lt; alexaClientSDK::avsCommon::avs::AudioInputStream &gt; getEncodedStream()</div><div class="ttdef"><b>Definition:</b> SpeechEncoder.cpp:117</div></div>
<div class="ttc" id="_encoder_context_8h_html"><div class="ttname"><a href="_encoder_context_8h.html">EncoderContext.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder_html_a527b26610b537a3eae200a08eb1c892d"><div class="ttname"><a href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a527b26610b537a3eae200a08eb1c892d">alexaClientSDK::speechencoder::SpeechEncoder::~SpeechEncoder</a></div><div class="ttdeci">~SpeechEncoder()</div><div class="ttdef"><b>Definition:</b> SpeechEncoder.cpp:59</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder_html_a61b44d15f354d5bf8a51921169d3825e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html#a61b44d15f354d5bf8a51921169d3825e">alexaClientSDK::speechencoder::SpeechEncoder::startEncoding</a></div><div class="ttdeci">bool startEncoding(const std::shared_ptr&lt; alexaClientSDK::avsCommon::avs::AudioInputStream &gt; &amp;inputStream, alexaClientSDK::avsCommon::utils::AudioFormat inputFormat, avsCommon::avs::AudioInputStream::Index begin, avsCommon::avs::AudioInputStream::Reader::Reference reference)</div><div class="ttdef"><b>Definition:</b> SpeechEncoder.cpp:64</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_html_a6b73c95dbde8b184f8b3176ff9a3f3f1"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#a6b73c95dbde8b184f8b3176ff9a3f3f1">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Index</a></div><div class="ttdeci">uint64_t Index</div><div class="ttdef"><b>Definition:</b> SharedDataStream.h:105</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1speechencoder_1_1_speech_encoder.html">alexaClientSDK::speechencoder::SpeechEncoder</a></div><div class="ttdef"><b>Definition:</b> SpeechEncoder.h:37</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
